(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@progress/kendo-angular-grid'), require('@portinari/portinari-ui'), require('totvs-log-web-foundation'), require('@angular/forms'), require('@progress/kendo-angular-dropdowns'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('totvs-log-web-foundation/src/kendo-grid', ['exports', '@angular/core', '@progress/kendo-angular-grid', '@portinari/portinari-ui', 'totvs-log-web-foundation', '@angular/forms', '@progress/kendo-angular-dropdowns', '@angular/common'], factory) :
    (global = global || self, factory((global['totvs-log-web-foundation'] = global['totvs-log-web-foundation'] || {}, global['totvs-log-web-foundation'].src = global['totvs-log-web-foundation'].src || {}, global['totvs-log-web-foundation'].src['kendo-grid'] = {}), global.ng.core, global.kendoAngularGrid, global.portinariUi, global['totvs-log-web-foundation'], global.ng.forms, global.kendoAngularDropdowns, global.ng.common));
}(this, (function (exports, core, kendoAngularGrid, portinariUi, totvsLogWebFoundation, forms, kendoAngularDropdowns, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var KendoGridExportComponent = /** @class */ (function () {
        function KendoGridExportComponent(grid, el, renderer) {
            this.grid = grid;
            this.el = el;
            this.renderer = renderer;
            this.popupActionsExport = [
                {
                    label: 'PDF',
                    action: this.exportAsPDF
                },
                {
                    label: 'Excel',
                    action: this.exportAsExcel
                }
            ];
            this._posInGroup = false;
        }
        Object.defineProperty(KendoGridExportComponent.prototype, "posInGroup", {
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._posInGroup = convertToBoolean(value);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        KendoGridExportComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            if (this._posInGroup) {
                this.renderer.removeChild(this.el.nativeElement, ((/** @type {?} */ (this.el.nativeElement))).children[0]);
                this.renderer.addClass(this.renderer.parentNode(this.el.nativeElement), 'k-grid-toolbar-hidden');
            }
        };
        /**
         * @return {?}
         */
        KendoGridExportComponent.prototype.exportAsPDF = /**
         * @return {?}
         */
        function () {
            this.grid.saveAsPDF();
        };
        /**
         * @return {?}
         */
        KendoGridExportComponent.prototype.exportAsExcel = /**
         * @return {?}
         */
        function () {
            this.grid.saveAsExcel();
        };
        KendoGridExportComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-kendo-grid-export',
                        template: "<span name=\"k-grid-export-space\">&nbsp;</span>\n<div class=\"k-grid-export\">\n  <span\n    #export\n    class=\"po-icon po-icon-export\"\n    p-tooltip=\"Exportar\"\n    p-tooltip-position=\"top\"\n    (click)=\"popup.toggle()\">\n  </span>\n  <po-popup\n    #popup\n    p-position=\"left\"\n    [p-target]=\"export\"\n    [p-actions]=\"popupActionsExport\">\n  </po-popup>\n</div>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        KendoGridExportComponent.ctorParameters = function () { return [
            { type: kendoAngularGrid.GridComponent, decorators: [{ type: core.Host }] },
            { type: core.ElementRef },
            { type: core.Renderer2 }
        ]; };
        KendoGridExportComponent.propDecorators = {
            posInGroup: [{ type: core.Input, args: ['pos-in-group',] }]
        };
        return KendoGridExportComponent;
    }());
    if (false) {
        /** @type {?} */
        KendoGridExportComponent.prototype.popupActionsExport;
        /**
         * @type {?}
         * @private
         */
        KendoGridExportComponent.prototype._posInGroup;
        /**
         * @type {?}
         * @private
         */
        KendoGridExportComponent.prototype.grid;
        /**
         * @type {?}
         * @private
         */
        KendoGridExportComponent.prototype.el;
        /**
         * @type {?}
         * @private
         */
        KendoGridExportComponent.prototype.renderer;
    }
    /**
     * @param {?} val
     * @return {?}
     */
    function convertToBoolean(val) {
        if (typeof val === 'string') {
            val = val.toLowerCase().trim();
            return (val === 'true' || val === 'on' || val === '');
        }
        if (typeof val === 'number') {
            return val === 1;
        }
        return !!val;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var KendoGridExportModule = /** @class */ (function () {
        function KendoGridExportModule() {
        }
        KendoGridExportModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            KendoGridExportComponent
                        ],
                        imports: [
                            kendoAngularGrid.GridModule,
                            portinariUi.PoPopupModule
                        ],
                        exports: [
                            KendoGridExportComponent
                        ]
                    },] }
        ];
        return KendoGridExportModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var flatten = (/**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        /** @type {?} */
        var filters = (filter || {}).filters;
        if (filters) {
            return filters.reduce((/**
             * @param {?} acc
             * @param {?} curr
             * @return {?}
             */
            function (acc, curr) { return acc.concat(curr.filters ? flatten(curr) : [curr]); }), []);
        }
        return [];
    });
    var ɵ0 = flatten;
    var KendoGridFilterEnumComponent = /** @class */ (function () {
        function KendoGridFilterEnumComponent(global) {
            this.global = global;
            this.options = [];
            this.selectedOptions = [];
        }
        /**
         * @return {?}
         */
        KendoGridFilterEnumComponent.prototype.filterOptions = /**
         * @return {?}
         */
        function () {
            var _a;
            (_a = this.selectedOptions).splice.apply(_a, __spread([0, this.selectedOptions.length], flatten(this.currentFilter).map((/**
             * @param {?} __0
             * @return {?}
             */
            function (_a) {
                var value = _a.value;
                return value;
            }))));
            return this.selectedOptions;
        };
        /**
         * @param {?} values
         * @return {?}
         */
        KendoGridFilterEnumComponent.prototype.changeFiltro = /**
         * @param {?} values
         * @return {?}
         */
        function (values) {
            var _this = this;
            this.filterService.filter({
                filters: values.map((/**
                 * @param {?} value
                 * @return {?}
                 */
                function (value) { return ({
                    field: _this.field,
                    operator: _this.applyFilter.bind(_this),
                    value: value,
                    ignoreCase: false
                }); })),
                logic: 'or'
            });
        };
        /**
         * @param {?} instance
         * @param {?} valor
         * @param {?} ignoreCase
         * @return {?}
         */
        KendoGridFilterEnumComponent.prototype.applyFilter = /**
         * @param {?} instance
         * @param {?} valor
         * @param {?} ignoreCase
         * @return {?}
         */
        function (instance, valor, ignoreCase) {
            /** @type {?} */
            var instanceValue = instance.hasOwnProperty('value') ? instance.value : instance.toString();
            return instanceValue === valor;
        };
        KendoGridFilterEnumComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-kendo-grid-filter-enum',
                        template: "<kendo-multiselect\n  [placeholder]=\"placeholder\"\n  [data]=\"options\"\n  textField=\"label\"\n  valueField=\"value\"\n  [valuePrimitive]=\"true\"\n  [value]=\"filterOptions()\"\n  (valueChange)=\"changeFiltro($event)\">\n  <kendo-multiselect-messages\n    [clearTitle]=\"global.i18n.literals['clearTitle']\"\n    [noDataText]=\"global.i18n.literals['nenhumDadoEncontrado']\">\n  </kendo-multiselect-messages>\n</kendo-multiselect>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        KendoGridFilterEnumComponent.ctorParameters = function () { return [
            { type: totvsLogWebFoundation.GlobalService }
        ]; };
        KendoGridFilterEnumComponent.propDecorators = {
            currentFilter: [{ type: core.Input }],
            filterService: [{ type: core.Input }],
            field: [{ type: core.Input }],
            placeholder: [{ type: core.Input }],
            options: [{ type: core.Input }]
        };
        return KendoGridFilterEnumComponent;
    }());
    if (false) {
        /** @type {?} */
        KendoGridFilterEnumComponent.prototype.currentFilter;
        /** @type {?} */
        KendoGridFilterEnumComponent.prototype.filterService;
        /** @type {?} */
        KendoGridFilterEnumComponent.prototype.field;
        /** @type {?} */
        KendoGridFilterEnumComponent.prototype.placeholder;
        /** @type {?} */
        KendoGridFilterEnumComponent.prototype.options;
        /** @type {?} */
        KendoGridFilterEnumComponent.prototype.selectedOptions;
        /** @type {?} */
        KendoGridFilterEnumComponent.prototype.global;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var KendoGridFilterEnumModule = /** @class */ (function () {
        function KendoGridFilterEnumModule() {
        }
        KendoGridFilterEnumModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            KendoGridFilterEnumComponent
                        ],
                        imports: [
                            kendoAngularGrid.GridModule,
                            forms.FormsModule,
                            kendoAngularDropdowns.DropDownsModule,
                        ],
                        exports: [
                            KendoGridFilterEnumComponent
                        ]
                    },] }
        ];
        return KendoGridFilterEnumModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var KendoGridMessagesComponent = /** @class */ (function () {
        function KendoGridMessagesComponent(global, changeDetectorRef) {
            this.global = global;
            this.changeDetectorRef = changeDetectorRef;
        }
        /**
         * @return {?}
         */
        KendoGridMessagesComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.changeDetectorRef.detectChanges();
        };
        KendoGridMessagesComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-kendo-grid-messages',
                        template: "<kendo-grid-messages\n    [noRecords]=\"global.i18n.literals['nenhumDadoEncontrado']\"\n    [columnMenu]=\"global.i18n.literals['opcoesDaColuna']\"\n    [columns]=\"global.i18n.literals['colunaMenuGrid']\"\n    [filter]=\"global.i18n.literals['filtroMenuGrid']\"\n    [sortAscending]=\"global.i18n.literals['ordenarMenuGrid']\"\n    [sortDescending]=\"global.i18n.literals['ordenarMenuGrid']\"\n    [columnsApply]=\"global.i18n.literals['colunasAplicarMenuGrid']\"\n    [groupPanelEmpty]=\"global.i18n.literals['arrasteAColunaGridMessagem']\"\n    [columnsReset]=\"global.i18n.literals['colunasRestaurarMenuGrid']\"\n    [filterClearButton]=\"global.i18n.literals['colunasRestaurarMenuGrid']\"\n    [filterAfterOperator]=\"global.i18n.literals['depoisFiltroGrid']\"\n    [filterAfterOrEqualOperator]=\"global.i18n.literals['depoisOuIgualFiltroGrid']\"\n    [filterBooleanAll]=\"global.i18n.literals['todosBooleanFiltroGrid']\"\n    [filterContainsOperator]=\"global.i18n.literals['contemFiltroGrid']\"\n    [filterEndsWithOperator]=\"global.i18n.literals['terminaComFiltroGrid']\"\n    [filterAndLogic]=\"global.i18n.literals['eLogicoFiltroGrid']\"\n    [filterBeforeOperator]=\"global.i18n.literals['antesFiltroGrid']\"\n    [filterBeforeOrEqualOperator]=\"global.i18n.literals['anteriorOuIgualFiltroGrid']\"\n    [filterEqOperator]=\"global.i18n.literals['eIgualFiltroGrid']\"\n    [filterFilterButton]=\"global.i18n.literals['filtroGrid']\"\n    [filterGtOperator]=\"global.i18n.literals['eMelhorQueFiltroGrid']\"\n    [filterGteOperator]=\"global.i18n.literals['eMaiorQueOuIgualFiltroGrid']\"\n    [filterIsEmptyOperator]=\"global.i18n.literals['estaVaziaFiltroGrid']\"\n    [filterIsNotEmptyOperator]=\"global.i18n.literals['naoEstaVaziaFiltroGrid']\"\n    [filterIsNotNullOperator]=\"global.i18n.literals['naoNuloFiltroGrid']\"\n    [filterIsNullOperator]=\"global.i18n.literals['eNuloFiltroGrid']\"\n    [filterIsTrue]=\"global.i18n.literals['verdadeiroFiltroGrid']\"\n    [filterLtOperator]=\"global.i18n.literals['eMenosDoQueFIltroGrid']\"\n    [filterLteOperator]=\"global.i18n.literals['eMenorOuIgualFiltroGrid']\"\n    [filterNotContainsOperator]=\"global.i18n.literals['naoContemFiltroGrid']\"\n    [filterNotEqOperator]=\"global.i18n.literals['naoIgualFiltroGrid']\"\n    [filterOrLogic]=\"global.i18n.literals['ouLogicoFiltroGrid']\"\n    [filterStartsWithOperator]=\"global.i18n.literals['comecaComFiltroGrid']\">\n</kendo-grid-messages>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        KendoGridMessagesComponent.ctorParameters = function () { return [
            { type: totvsLogWebFoundation.GlobalService },
            { type: core.ChangeDetectorRef }
        ]; };
        return KendoGridMessagesComponent;
    }());
    if (false) {
        /** @type {?} */
        KendoGridMessagesComponent.prototype.global;
        /** @type {?} */
        KendoGridMessagesComponent.prototype.changeDetectorRef;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var KendoGridMessagesModule = /** @class */ (function () {
        function KendoGridMessagesModule() {
        }
        KendoGridMessagesModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            KendoGridMessagesComponent
                        ],
                        imports: [
                            kendoAngularGrid.GridModule
                        ],
                        exports: [
                            KendoGridMessagesComponent
                        ]
                    },] }
        ];
        return KendoGridMessagesModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ToolTipInKGridDirective = /** @class */ (function () {
        function ToolTipInKGridDirective(el, tooltip) {
            this.el = el;
            this.tooltip = tooltip;
        }
        /**
         * @return {?}
         */
        ToolTipInKGridDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            ((/** @type {?} */ (this.el.nativeElement))).removeAllListeners('mouseenter');
            if (this.tooltip) {
                ((/** @type {?} */ (this.el.nativeElement))).addEventListener('mouseover', this.showTooltip.bind(this));
                // tslint:disable-next-line: no-string-literal
                this.tooltip['createTooltip']();
                this.tooltip.onMouseLeave();
            }
        };
        /**
         * @param {?} e
         * @return {?}
         */
        ToolTipInKGridDirective.prototype.showTooltip = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            /** @type {?} */
            var element = (/** @type {?} */ (e.target));
            if ((element.nodeName === 'TD' || element.nodeName === 'TH' ||
                element.parentNode.nodeName === 'TD' || element.parentNode.nodeName === 'TH')
                && element.offsetWidth < element.scrollWidth) {
                this.tooltip.tooltip = element.innerText;
                // tslint:disable-next-line: no-string-literal
                this.tooltip['poControlPosition'].setElements(this.tooltip['tooltipContent'], this.tooltip['tooltipOffset'], element);
                this.tooltip.onMouseEnter();
            }
            else {
                this.tooltip.onMouseLeave();
            }
        };
        ToolTipInKGridDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[libToolTipInKGrid]'
                    },] }
        ];
        /** @nocollapse */
        ToolTipInKGridDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: portinariUi.PoTooltipDirective, decorators: [{ type: core.Host }, { type: core.Optional }] }
        ]; };
        return ToolTipInKGridDirective;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        ToolTipInKGridDirective.prototype.el;
        /**
         * @type {?}
         * @private
         */
        ToolTipInKGridDirective.prototype.tooltip;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TooltipInKGridModule = /** @class */ (function () {
        function TooltipInKGridModule() {
        }
        TooltipInKGridModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [ToolTipInKGridDirective],
                        imports: [
                            common.CommonModule,
                        ],
                        exports: [ToolTipInKGridDirective]
                    },] }
        ];
        return TooltipInKGridModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@dynamic
     */
    var FixComboInKGridDirective = /** @class */ (function () {
        function FixComboInKGridDirective(el, document) {
            this.el = el;
            this.document = document;
            this.container = [];
        }
        /**
         * @return {?}
         */
        FixComboInKGridDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var container = this.el.nativeElement.querySelector('.po-combo-container');
            if (container) {
                this.container.push(this.document.body.appendChild(container));
            }
        };
        /**
         * @return {?}
         */
        FixComboInKGridDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.container.forEach((/**
             * @param {?} x
             * @return {?}
             */
            function (x) {
                _this.document.body.removeChild(x);
            }));
        };
        FixComboInKGridDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[libFixComboInKGrid]',
                    },] }
        ];
        /** @nocollapse */
        FixComboInKGridDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: Document, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] }
        ]; };
        return FixComboInKGridDirective;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        FixComboInKGridDirective.prototype.container;
        /**
         * @type {?}
         * @private
         */
        FixComboInKGridDirective.prototype.el;
        /**
         * @type {?}
         * @private
         */
        FixComboInKGridDirective.prototype.document;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FixComboInKGridModule = /** @class */ (function () {
        function FixComboInKGridModule() {
        }
        FixComboInKGridModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [FixComboInKGridDirective],
                        imports: [
                            common.CommonModule,
                        ],
                        exports: [FixComboInKGridDirective]
                    },] }
        ];
        return FixComboInKGridModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var FndKendoGridModule = /** @class */ (function () {
        function FndKendoGridModule() {
        }
        FndKendoGridModule.decorators = [
            { type: core.NgModule, args: [{
                        exports: [
                            kendoAngularGrid.GridModule,
                            kendoAngularGrid.PDFModule,
                            kendoAngularGrid.ExcelModule,
                            KendoGridMessagesModule,
                            KendoGridExportModule,
                            KendoGridFilterEnumModule,
                            TooltipInKGridModule,
                            FixComboInKGridModule
                        ]
                    },] }
        ];
        return FndKendoGridModule;
    }());

    exports.FixComboInKGridDirective = FixComboInKGridDirective;
    exports.FixComboInKGridModule = FixComboInKGridModule;
    exports.FndKendoGridModule = FndKendoGridModule;
    exports.KendoGridExportComponent = KendoGridExportComponent;
    exports.KendoGridExportModule = KendoGridExportModule;
    exports.KendoGridFilterEnumComponent = KendoGridFilterEnumComponent;
    exports.KendoGridFilterEnumModule = KendoGridFilterEnumModule;
    exports.KendoGridMessagesComponent = KendoGridMessagesComponent;
    exports.KendoGridMessagesModule = KendoGridMessagesModule;
    exports.ToolTipInKGridDirective = ToolTipInKGridDirective;
    exports.TooltipInKGridModule = TooltipInKGridModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=totvs-log-web-foundation-src-kendo-grid.umd.js.map
