(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('totvs-log-web-foundation'), require('@angular/core'), require('@angular/forms'), require('@angular/router'), require('@portinari/portinari-ui'), require('rxjs'), require('rxjs/operators'), require('totvs-log-base-foundation'), require('totvs-log-base-foundation/src/sl-unidade'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('totvs-log-web-foundation/src/sl-unidade', ['exports', 'totvs-log-web-foundation', '@angular/core', '@angular/forms', '@angular/router', '@portinari/portinari-ui', 'rxjs', 'rxjs/operators', 'totvs-log-base-foundation', 'totvs-log-base-foundation/src/sl-unidade', '@angular/common'], factory) :
    (global = global || self, factory((global['totvs-log-web-foundation'] = global['totvs-log-web-foundation'] || {}, global['totvs-log-web-foundation'].src = global['totvs-log-web-foundation'].src || {}, global['totvs-log-web-foundation'].src['sl-unidade'] = {}), global['totvs-log-web-foundation'], global.ng.core, global.ng.forms, global.ng.router, global.portinariUi, global.rxjs, global.rxjs.operators, global.totvsLogBaseFoundation, global.slUnidade, global.ng.common));
}(this, (function (exports, totvsLogWebFoundation, core, forms, router, portinariUi, rxjs, operators, totvsLogBaseFoundation, slUnidade, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UnidadeSegmentoEnum = /** @class */ (function (_super) {
        __extends(UnidadeSegmentoEnum, _super);
        function UnidadeSegmentoEnum(value, label, disabled) {
            if (disabled === void 0) { disabled = false; }
            return _super.call(this, value, label, disabled) || this;
        }
        /**
         * @return {?}
         */
        UnidadeSegmentoEnum.OPERADOR_LOGISTICO = /**
         * @return {?}
         */
        function () {
            return new UnidadeSegmentoEnum('OPERADOR_LOGISTICO', 'operadorLogistico');
        };
        /**
         * @return {?}
         */
        UnidadeSegmentoEnum.RECINTO_ADUANEIRO = /**
         * @return {?}
         */
        function () {
            return new UnidadeSegmentoEnum('RECINTO_ADUANEIRO', 'operadorAduaneiro', true);
        };
        /**
         * @return {?}
         */
        UnidadeSegmentoEnum.DISTRIBUIDOR = /**
         * @return {?}
         */
        function () {
            return new UnidadeSegmentoEnum('DISTRIBUIDOR', 'distribuidor', false);
        };
        /**
         * @return {?}
         */
        UnidadeSegmentoEnum.INDUSTRIA = /**
         * @return {?}
         */
        function () {
            return new UnidadeSegmentoEnum('INDUSTRIA', 'industria', false);
        };
        /**
         * @return {?}
         */
        UnidadeSegmentoEnum.VAREJO = /**
         * @return {?}
         */
        function () {
            return new UnidadeSegmentoEnum('VAREJO', 'varejo', true);
        };
        UnidadeSegmentoEnum.values = [
            UnidadeSegmentoEnum.OPERADOR_LOGISTICO(),
            UnidadeSegmentoEnum.RECINTO_ADUANEIRO(),
            UnidadeSegmentoEnum.DISTRIBUIDOR(),
            UnidadeSegmentoEnum.INDUSTRIA(),
            UnidadeSegmentoEnum.VAREJO()
        ];
        return UnidadeSegmentoEnum;
    }(totvsLogWebFoundation.Enum));
    if (false) {
        /** @type {?} */
        UnidadeSegmentoEnum.values;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Unidade = /** @class */ (function () {
        function Unidade() {
        }
        return Unidade;
    }());
    if (false) {
        /** @type {?} */
        Unidade.prototype.nome;
        /** @type {?} */
        Unidade.prototype.segmento;
        /** @type {?} */
        Unidade.prototype.cnpj;
        /** @type {?} */
        Unidade.prototype.unidadeFederativa;
        /** @type {?} */
        Unidade.prototype.inscricaoEstadual;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function IUnidadeIncluirControle() { }
    if (false) {
        /** @type {?} */
        IUnidadeIncluirControle.prototype.name;
        /** @type {?} */
        IUnidadeIncluirControle.prototype.validators;
        /** @type {?} */
        IUnidadeIncluirControle.prototype.get;
        /** @type {?} */
        IUnidadeIncluirControle.prototype.value;
        /** @type {?} */
        IUnidadeIncluirControle.prototype.withError;
    }
    /**
     * @record
     */
    function IUnidadeIncluirControles() { }
    if (false) {
        /** @type {?} */
        IUnidadeIncluirControles.prototype.nome;
        /** @type {?} */
        IUnidadeIncluirControles.prototype.segmento;
        /** @type {?} */
        IUnidadeIncluirControles.prototype.cnpj;
        /** @type {?} */
        IUnidadeIncluirControles.prototype.unidadeFederativa;
        /** @type {?} */
        IUnidadeIncluirControles.prototype.inscricaoEstadual;
    }
    var UnidadeIncluirForm = /** @class */ (function () {
        function UnidadeIncluirForm(formBuilder) {
            var _this = this;
            this.formBuilder = formBuilder;
            this._controles = {
                nome: this.criarControle('nome', forms.Validators.required),
                segmento: this.criarControle('segmento', forms.Validators.required),
                cnpj: this.criarControle('cnpj', totvsLogBaseFoundation.cnpjValidator()),
                unidadeFederativa: this.criarControle('unidadeFederativa'),
                inscricaoEstadual: this.criarControle('inscricaoEstadual', totvsLogBaseFoundation.inscricaoEstadualValidator((/**
                 * @return {?}
                 */
                function () { return _this.controles.unidadeFederativa ? _this.controles.unidadeFederativa.value() : ''; })))
            };
            this._grupo = this.formBuilder.group(this.criarControles());
            this.utils = new totvsLogBaseFoundation.FormUtils(this.grupo);
        }
        Object.defineProperty(UnidadeIncluirForm.prototype, "controles", {
            get: /**
             * @return {?}
             */
            function () {
                return this._controles;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UnidadeIncluirForm.prototype, "grupo", {
            get: /**
             * @return {?}
             */
            function () {
                return this._grupo;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} formBuilder
         * @return {?}
         */
        UnidadeIncluirForm.of = /**
         * @param {?} formBuilder
         * @return {?}
         */
        function (formBuilder) {
            return new UnidadeIncluirForm(formBuilder);
        };
        /**
         * @return {?}
         */
        UnidadeIncluirForm.prototype.formEstaValido = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var formValido = this.utils.executeFormValidation();
            return formValido && this.grupo.valid;
        };
        /**
         * @return {?}
         */
        UnidadeIncluirForm.prototype.getUnidadeIncluir = /**
         * @return {?}
         */
        function () {
            return {
                id: undefined,
                nome: this.controles.nome.value(),
                cnpj: this.controles.cnpj.value(),
                inscricaoEstadual: this.controles.inscricaoEstadual.value(),
                unidadeFederativa: this.controles.unidadeFederativa.value(),
                segmento: this.controles.segmento.value()
            };
        };
        /**
         * @private
         * @return {?}
         */
        UnidadeIncluirForm.prototype.criarControles = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var controles = {};
            for (var chave in this.controles) {
                if (this.controles.hasOwnProperty(chave)) {
                    controles[chave] = [null, this.controles[chave].validators];
                }
            }
            return controles;
        };
        /**
         * @private
         * @param {?} nome
         * @param {...?} validadores
         * @return {?}
         */
        UnidadeIncluirForm.prototype.criarControle = /**
         * @private
         * @param {?} nome
         * @param {...?} validadores
         * @return {?}
         */
        function (nome) {
            var _this = this;
            var validadores = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                validadores[_i - 1] = arguments[_i];
            }
            return {
                name: nome,
                validators: validadores,
                get: (/**
                 * @return {?}
                 */
                function () { return _this.grupo ? _this.grupo.get(nome) : null; }),
                value: (/**
                 * @return {?}
                 */
                function () { return _this.grupo ? _this.grupo.get(nome).value : null; }),
                withError: (/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return (_this.grupo.get(nome).dirty && _this.grupo.get(nome).errors && _this.grupo.get(nome).errors[error]); })
            };
        };
        return UnidadeIncluirForm;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        UnidadeIncluirForm.prototype._controles;
        /**
         * @type {?}
         * @private
         */
        UnidadeIncluirForm.prototype._grupo;
        /**
         * @type {?}
         * @private
         */
        UnidadeIncluirForm.prototype.utils;
        /**
         * @type {?}
         * @private
         */
        UnidadeIncluirForm.prototype.formBuilder;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UnidadeIncluirComponent = /** @class */ (function () {
        function UnidadeIncluirComponent(global, formBuilder, router, activatedRoute, unidadeIncluirService) {
            var _this = this;
            this.global = global;
            this.router = router;
            this.activatedRoute = activatedRoute;
            this.unidadeIncluirService = unidadeIncluirService;
            this.esconderBotaoCancelar = false;
            this.rotaAposAcoes = './../';
            this._acoesPagina = [];
            this._opcoesEstado = totvsLogWebFoundation.opcoesUFThfCombo();
            this._opcoesSegmento = UnidadeSegmentoEnum.values.map((/**
             * @param {?} segmento
             * @return {?}
             */
            function (segmento) { return segmento.toSelect(_this.global); }));
            this._form = UnidadeIncluirForm.of(formBuilder);
        }
        Object.defineProperty(UnidadeIncluirComponent.prototype, "acoesPagina", {
            get: /**
             * @return {?}
             */
            function () {
                return this._acoesPagina;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UnidadeIncluirComponent.prototype, "itensBreadcrumb", {
            get: /**
             * @return {?}
             */
            function () {
                return this._itensBreadcrumb;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UnidadeIncluirComponent.prototype, "form", {
            get: /**
             * @return {?}
             */
            function () {
                return this._form;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UnidadeIncluirComponent.prototype, "opcoesEstado", {
            get: /**
             * @return {?}
             */
            function () {
                return this._opcoesEstado;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UnidadeIncluirComponent.prototype, "opcoesSegmento", {
            get: /**
             * @return {?}
             */
            function () {
                return this._opcoesSegmento;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        UnidadeIncluirComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.definirAcoesPagina();
        };
        /**
         * @param {?} uf
         * @return {?}
         */
        UnidadeIncluirComponent.prototype.alterarUnidadeFederativa = /**
         * @param {?} uf
         * @return {?}
         */
        function (uf) {
            var _this = this;
            if (uf) {
                this.form.controles.inscricaoEstadual.get().reset();
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    _this.inscricaoEstadual.focus();
                }), 50);
            }
        };
        /**
         * @return {?}
         */
        UnidadeIncluirComponent.prototype.definirAcoesPagina = /**
         * @return {?}
         */
        function () {
            this._acoesPagina = [
                {
                    label: this.global.i18n.literals.salvar,
                    action: this.salvar.bind(this)
                }
            ];
            if (!this.esconderBotaoCancelar) {
                this._acoesPagina.push({
                    label: this.global.i18n.literals.cancelar,
                    action: this.cancelar.bind(this)
                });
            }
        };
        /**
         * @return {?}
         */
        UnidadeIncluirComponent.prototype.salvar = /**
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.form.formEstaValido()) {
                this.global.loading.executeWithLoading((/**
                 * @return {?}
                 */
                function () { return _this.unidadeIncluirService.Post(_this.form.getUnidadeIncluir()); })).pipe(operators.concatMap((/**
                 * @return {?}
                 */
                function () { return rxjs.of(null).pipe(operators.delay(250)); }))).subscribe((/**
                 * @return {?}
                 */
                function () {
                    _this.global.msg.showMessage(new totvsLogBaseFoundation.BaseMessage({
                        literal: 'unidadeIncluidaSucesso'
                    }).withMessageType(totvsLogBaseFoundation.ShowMessageType.NotificationSuccess));
                    _this.voltar();
                }), (/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) {
                    console.error(error);
                }));
            }
        };
        /**
         * @return {?}
         */
        UnidadeIncluirComponent.prototype.cancelar = /**
         * @return {?}
         */
        function () {
            this.voltar();
        };
        /**
         * @private
         * @return {?}
         */
        UnidadeIncluirComponent.prototype.voltar = /**
         * @private
         * @return {?}
         */
        function () {
            this.router.navigate([this.rotaAposAcoes], {
                relativeTo: this.activatedRoute
            });
        };
        UnidadeIncluirComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-unidade-incluir',
                        template: "<po-page-default\n  [p-title]=\"global.i18n.literals['novaUnidade']\"\n  [p-actions]=\"acoesPagina\"\n  [p-breadcrumb]=\"itensBreadcrumb\">\n\n  <form \n    [formGroup]=\"form.grupo\"\n    class=\"po-row\">\n\n    <div class=\"po-sm-12 po-md-6 po-lg-3 po-xl-3\">\n      <po-input\n        [name]=\"form.controles.nome.name\"\n        [formControlName]=\"form.controles.nome.name\"\n        [p-label]=\"global.i18n.literals['nome']\"\n        [p-placeholder]=\"global.i18n.literals['informeNome']\"\n        p-focus>\n      </po-input>\n      <p\n        [hidden]=\"!form.controles.nome.withError('required')\"\n        class=\"po-mb-1 po-sm-12 po-md-12 po-lg-12 po-xl-12 po-text-color-07 po-font-text-small sem-padding-left\">\n        ! {{ global.i18n.literals['informeNome'] }}\n      </p>\n    </div>\n\n    <div class=\"po-sm-12 po-md-6 po-lg-3 po-xl-3\">\n      <po-select\n        [name]=\"form.controles.segmento.name\"\n        [formControlName]=\"form.controles.segmento.name\"\n        [p-label]=\"global.i18n.literals['segmento']\"\n        [p-placeholder]=\"global.i18n.literals['selecioneSegmento']\"\n        [p-options]=\"opcoesSegmento\">\n      </po-select>\n      <p\n        [hidden]=\"!form.controles.segmento.withError('required')\"\n        class=\"po-mb-1 po-sm-12 po-md-12 po-lg-12 po-xl-12 po-text-color-07 po-font-text-small sem-padding-left\">\n        ! {{ global.i18n.literals['selecioneSegmento'] }}\n      </p>\n    </div>\n\n    <div class=\"po-sm-12 po-md-6 po-lg-3 po-xl-3\">\n      <po-input\n        [name]=\"form.controles.cnpj.name\"\n        [formControlName]=\"form.controles.cnpj.name\"\n        [p-label]=\"global.i18n.literals['cnpj']\"\n        [p-placeholder]=\"global.i18n.literals['informeNumero']\"\n        p-mask=\"99.999.999/9999-99\"\n        p-optional>\n      </po-input>\n      <p\n        [hidden]=\"!form.controles.cnpj.withError('cnpjInvalido')\"\n        class=\"po-mb-1 po-sm-12 po-md-12 po-lg-12 po-xl-12 po-text-color-07 po-font-text-small sem-padding-left\">\n        ! {{ global.i18n.literals['cnpjInvalido'] }}\n      </p>\n    </div>\n\n    <div class=\"po-sm-12 po-md-6 po-lg-3 po-xl-3\">\n      <po-select\n        [name]=\"form.controles.unidadeFederativa.name\"\n        [formControlName]=\"form.controles.unidadeFederativa.name\"\n        [p-label]=\"global.i18n.literals['estado']\"\n        [p-placeholder]=\"global.i18n.literals['selecioneEstado']\"\n        [p-options]=\"opcoesEstado\"\n        p-optional\n        (p-change)=\"alterarUnidadeFederativa($event)\">\n      </po-select>\n    </div>\n\n    <div class=\"po-sm-12 po-md-6 po-lg-3 po-xl-3\">\n      <po-input\n        #inscricaoEstadual\n        [name]=\"form.controles.inscricaoEstadual.name\"\n        [formControlName]=\"form.controles.inscricaoEstadual.name\"\n        [p-label]=\"this.global.i18n.literals['inscricaoEstadual']\"\n        [p-placeholder]=\"this.global.i18n.literals['informeNumero']\"\n        [p-disabled]=\"!form.controles.unidadeFederativa.value()\"\n        p-mask=\"999999999999999\"\n        p-optional>\n      </po-input>\n      <p\n        [hidden]=\"!form.controles.inscricaoEstadual.withError('inscricaoEstadualInvalido')\"\n        class=\"po-mb-1 po-sm-12 po-md-12 po-lg-12 po-xl-12 po-text-color-07 po-font-text-small sem-padding-left\">\n        ! {{ global.i18n.literals['ieInvalido'] }}\n      </p>\n    </div>\n  </form>\n</po-page-default>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        UnidadeIncluirComponent.ctorParameters = function () { return [
            { type: totvsLogWebFoundation.GlobalService },
            { type: forms.FormBuilder },
            { type: router.Router },
            { type: router.ActivatedRoute },
            { type: slUnidade.UnidadeIncluirService }
        ]; };
        UnidadeIncluirComponent.propDecorators = {
            esconderBotaoCancelar: [{ type: core.Input }],
            rotaAposAcoes: [{ type: core.Input }],
            inscricaoEstadual: [{ type: core.ViewChild, args: ['inscricaoEstadual', { static: true },] }]
        };
        return UnidadeIncluirComponent;
    }());
    if (false) {
        /** @type {?} */
        UnidadeIncluirComponent.prototype.esconderBotaoCancelar;
        /** @type {?} */
        UnidadeIncluirComponent.prototype.rotaAposAcoes;
        /** @type {?} */
        UnidadeIncluirComponent.prototype.inscricaoEstadual;
        /**
         * @type {?}
         * @private
         */
        UnidadeIncluirComponent.prototype._acoesPagina;
        /**
         * @type {?}
         * @private
         */
        UnidadeIncluirComponent.prototype._itensBreadcrumb;
        /**
         * @type {?}
         * @private
         */
        UnidadeIncluirComponent.prototype._form;
        /**
         * @type {?}
         * @private
         */
        UnidadeIncluirComponent.prototype._opcoesEstado;
        /**
         * @type {?}
         * @private
         */
        UnidadeIncluirComponent.prototype._opcoesSegmento;
        /** @type {?} */
        UnidadeIncluirComponent.prototype.global;
        /**
         * @type {?}
         * @private
         */
        UnidadeIncluirComponent.prototype.router;
        /**
         * @type {?}
         * @private
         */
        UnidadeIncluirComponent.prototype.activatedRoute;
        /**
         * @type {?}
         * @private
         */
        UnidadeIncluirComponent.prototype.unidadeIncluirService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UnidadeIncluirModule = /** @class */ (function () {
        function UnidadeIncluirModule() {
        }
        UnidadeIncluirModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            UnidadeIncluirComponent
                        ],
                        imports: [
                            common.CommonModule,
                            totvsLogWebFoundation.AuthModule,
                            totvsLogWebFoundation.FndModule,
                            forms.FormsModule,
                            forms.ReactiveFormsModule,
                            portinariUi.PoPageModule,
                            portinariUi.PoFieldModule
                        ],
                        exports: [
                            UnidadeIncluirComponent
                        ]
                    },] }
        ];
        return UnidadeIncluirModule;
    }());

    exports.Unidade = Unidade;
    exports.UnidadeIncluirComponent = UnidadeIncluirComponent;
    exports.UnidadeIncluirForm = UnidadeIncluirForm;
    exports.UnidadeIncluirModule = UnidadeIncluirModule;
    exports.UnidadeSegmentoEnum = UnidadeSegmentoEnum;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=totvs-log-web-foundation-src-sl-unidade.umd.js.map
