(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('totvs-log-base-foundation'), require('rxjs'), require('rxjs/operators'), require('@angular/common/http'), require('@portinari/portinari-ui'), require('@angular/common'), require('@angular/forms'), require('@angular/router')) :
    typeof define === 'function' && define.amd ? define('totvs-log-web-foundation', ['exports', '@angular/core', 'totvs-log-base-foundation', 'rxjs', 'rxjs/operators', '@angular/common/http', '@portinari/portinari-ui', '@angular/common', '@angular/forms', '@angular/router'], factory) :
    (global = global || self, factory(global['totvs-log-web-foundation'] = {}, global.ng.core, global.totvsLogBaseFoundation, global.rxjs, global.rxjs.operators, global.ng.common.http, global.portinariUi, global.ng.common, global.ng.forms, global.ng.router));
}(this, (function (exports, core, totvsLogBaseFoundation, rxjs, operators, http, portinariUi, common, forms, router) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Serviço que realiza o carregamento das literais do serviço de internacionalização
     */
    var IntlLiteralsLoaderService = /** @class */ (function () {
        /**
         * Método construtor da classe
         * @param http Parâmetro do serviço de Http
         * @param poI18nService Parâmetro do serviço de internacionalização do Po
         */
        function IntlLiteralsLoaderService(http, poI18nService) {
            this.http = http;
            this.poI18nService = poI18nService;
            /**
             * Atributo com opções de internacionalização Web
             */
            this.webOptions = { context: '', language: '', url: '' };
        }
        /**
         * Método responsável por alterar as opções para carregamento de literais
         * @param options Parâmetro com as opções de internacionalização (url, language, context)
         */
        /**
         * Método responsável por alterar as opções para carregamento de literais
         * @param {?} options Parâmetro com as opções de internacionalização (url, language, context)
         * @return {?}
         */
        IntlLiteralsLoaderService.prototype.updateOptions = /**
         * Método responsável por alterar as opções para carregamento de literais
         * @param {?} options Parâmetro com as opções de internacionalização (url, language, context)
         * @return {?}
         */
        function (options) {
            var _this = this;
            /** @type {?} */
            var obs = new rxjs.Observable((/**
             * @param {?} observer
             * @return {?}
             */
            function (observer) {
                if (_this.optionsWasChanged(options)) {
                    Object.assign(_this.webOptions, options);
                    _this.load().subscribe((/**
                     * @param {?} x
                     * @return {?}
                     */
                    function (x) {
                        _this.cache = x;
                        observer.next(_this.cache);
                    }));
                }
                else if (_this.cache) {
                    observer.next(_this.cache);
                }
            }));
            return obs;
        };
        /**
         * Método responsável por realizar o carregamento inicial das literais
         */
        /**
         * Método responsável por realizar o carregamento inicial das literais
         * @return {?}
         */
        IntlLiteralsLoaderService.prototype.load = /**
         * Método responsável por realizar o carregamento inicial das literais
         * @return {?}
         */
        function () {
            var _this = this;
            return this.http.get(this.webOptions.url)
                .pipe(operators.map((/**
             * @param {?} res
             * @return {?}
             */
            function (res) {
                /** @type {?} */
                var s = (/** @type {?} */ (_this.poI18nService));
                s.config.contexts[_this.webOptions.context] = res;
                s.setVarI18n(s.config.contexts);
                return res;
            })), operators.mergeMap((/**
             * @param {?} res
             * @return {?}
             */
            function (res) { return _this.updateLiteralsFromPoContext(); })), operators.catchError((/**
             * @param {?} e
             * @param {?} caught
             * @return {?}
             */
            function (e, caught) { return caught; })));
        };
        /**
         * Detecta se ocorreram mudanças na configuração
         */
        /**
         * Detecta se ocorreram mudanças na configuração
         * @private
         * @param {?} options
         * @return {?}
         */
        IntlLiteralsLoaderService.prototype.optionsWasChanged = /**
         * Detecta se ocorreram mudanças na configuração
         * @private
         * @param {?} options
         * @return {?}
         */
        function (options) {
            return this.webOptions.context !== options.context
                || this.webOptions.url !== options.url
                || this.webOptions.language !== options.language;
        };
        /**
         * Método responsável por carregar as literais do contexto do Po
         */
        /**
         * Método responsável por carregar as literais do contexto do Po
         * @private
         * @return {?}
         */
        IntlLiteralsLoaderService.prototype.updateLiteralsFromPoContext = /**
         * Método responsável por carregar as literais do contexto do Po
         * @private
         * @return {?}
         */
        function () {
            return this.poI18nService.getLiterals({
                context: this.webOptions.context,
                language: this.webOptions.language
            }).pipe(operators.map((/**
             * @param {?} res
             * @return {?}
             */
            function (res) { return res; })));
        };
        IntlLiteralsLoaderService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        IntlLiteralsLoaderService.ctorParameters = function () { return [
            { type: http.HttpClient },
            { type: portinariUi.PoI18nService }
        ]; };
        return IntlLiteralsLoaderService;
    }());
    if (false) {
        /**
         * Atributo com opções de internacionalização Web
         * @type {?}
         * @private
         */
        IntlLiteralsLoaderService.prototype.webOptions;
        /**
         * Representa o cache da informação, em memória
         * @type {?}
         * @private
         */
        IntlLiteralsLoaderService.prototype.cache;
        /**
         * @type {?}
         * @private
         */
        IntlLiteralsLoaderService.prototype.http;
        /**
         * @type {?}
         * @private
         */
        IntlLiteralsLoaderService.prototype.poI18nService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Token de configuração da url de internacionalização
     * @type {?}
     */
    var INTL_CONFIG = new core.InjectionToken('Configurações da internacionalização');
    /**
     * Serviço de internacionalização
     */
    var IntlService = /** @class */ (function (_super) {
        __extends(IntlService, _super);
        /**
         * Método construtor da classe
         * @param config Parâmetro do serviço com as configurações de internacionalização
         * @param intlLiteralsLoader Parâmetro do serviço de carregamento de literais de internacionalização
         */
        function IntlService(config, intlLiteralsLoader) {
            var _this = _super.call(this, intlLiteralsLoader) || this;
            /** @type {?} */
            var matchedAppLanguage;
            if (config.supportedLanguages) {
                matchedAppLanguage = config.supportedLanguages.find((/**
                 * @param {?} appSupportedLanguage
                 * @return {?}
                 */
                function (appSupportedLanguage) {
                    return appSupportedLanguage.language === navigator.language;
                }));
                matchedAppLanguage = matchedAppLanguage ? matchedAppLanguage : IntlService.i18nConfig.default.language;
            }
            else {
                matchedAppLanguage = IntlService.i18nConfig.default.language;
                config.supportedLanguages = [{
                        language: IntlService.i18nConfig.default.language
                    }];
            }
            _this.updateOptions({
                context: IntlService.i18nConfig.default.context,
                language: matchedAppLanguage.language,
                url: config.url,
                supportedLanguages: config.supportedLanguages
            });
            return _this;
        }
        /**
         * Atributo com as configurações de internacionalização
         */
        IntlService.i18nConfig = {
            contexts: {},
            default: {
                language: 'pt-br',
                context: 'general',
                cache: true
            }
        };
        IntlService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        IntlService.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [INTL_CONFIG,] }] },
            { type: IntlLiteralsLoaderService }
        ]; };
        return IntlService;
    }(totvsLogBaseFoundation.I18nBaseService));
    if (false) {
        /**
         * Atributo com as configurações de internacionalização
         * @type {?}
         */
        IntlService.i18nConfig;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe/componente de mensagem
     */
    var MessageComponent = /** @class */ (function () {
        function MessageComponent() {
            /**
             * Atributo com o título da mensagem
             */
            this.messageTitle = '';
            /**
             * Atributo com o texto da mensagem
             */
            this.messageText = '';
            /**
             * Atributo com os detalhes da mensagem
             */
            this.messageDetails = '';
            /**
             * Atributo que recebe a ação de confirmação
             */
            this.messageConfirmAction = undefined;
            /**
             * Atributo que recebe a ação de cancelamento
             */
            this.messageCancelAction = undefined;
            /**
             * Atributo que recebe o tipo do link
             */
            this.messageLinkActionType = totvsLogBaseFoundation.ShowMessageLinkActionType.No;
            /**
             * Atributo que recebe o link
             */
            this.messageLinkAction = undefined;
            /**
             * Atributo que recebe o label do link
             */
            this.messageLinkLabel = '';
            /**
             * Atributo que indica se os detalhes da mensagem devem ser escondidos
             */
            this.hideDetails = true;
        }
        /**
         * Método responsável por disparar a abertura da dialog
         */
        /**
         * Método responsável por disparar a abertura da dialog
         * @return {?}
         */
        MessageComponent.prototype.openDialog = /**
         * Método responsável por disparar a abertura da dialog
         * @return {?}
         */
        function () {
            this.poModal.open();
        };
        /**
         * Método responsável por fechar a dialog
         */
        /**
         * Método responsável por fechar a dialog
         * @return {?}
         */
        MessageComponent.prototype.closeDialog = /**
         * Método responsável por fechar a dialog
         * @return {?}
         */
        function () {
            this.poModal.close();
        };
        /**
         * Método responsável por executar ação do link relacionado a mensagem
         */
        /**
         * Método responsável por executar ação do link relacionado a mensagem
         * @return {?}
         */
        MessageComponent.prototype.linkAction = /**
         * Método responsável por executar ação do link relacionado a mensagem
         * @return {?}
         */
        function () {
            this.messageLinkAction();
        };
        MessageComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-message',
                        template: "<po-modal\n  [p-title]=\"messageTitle\"\n  [p-primary-action]=\"messageConfirmAction\"\n  [p-secondary-action]=\"messageCancelAction\">\n  <div class=\"message-body\">\n    {{messageText}}\n    <p *ngIf=\"messageLinkActionType\">\n      <a href=\"javascript:void(0)\" (click)=\"linkAction()\">{{messageLinkLabel}}</a>\n    </p>\n    <br/>\n    <div *ngIf=\"messageDetails\" class=\"message-details\">\n      <a *ngIf=\"hideDetails\" class=\"show-details\" href=\"javascript:void(0);\" (click)=\"hideDetails = !hideDetails\">\n        <span class=\"po-icon po-icon-arrow-down\"></span>\n        Exibir detalhes\n      </a>\n      <a *ngIf=\"!hideDetails\" class=\"show-details\" href=\"javascript:void(0);\" (click)=\"hideDetails = !hideDetails\">\n        <span class=\"po-icon po-icon-arrow-up\"></span>\n        Ocultar detalhes\n      </a>\n      <p [ngClass]=\"{'hide-details': hideDetails}\">\n        {{messageDetails}}\n      </p>\n    </div>    \n  </div>\n</po-modal>",
                        styles: [".show-details{height:12px;font-family:NunitoSans-Bold;font-size:14px!important;line-height:1.71;text-align:left;color:#1d9abc;padding-top:13px;padding-bottom:15px;text-decoration:none}.hide-details{display:none}.message-body{overflow:hidden;margin-bottom:4px;margin-left:10px;vertical-align:top;min-height:45px}.message-details{margin-top:15px;text-align:center;border-top:1px solid #dbdedf}"]
                    }] }
        ];
        MessageComponent.propDecorators = {
            poModal: [{ type: core.ViewChild, args: [portinariUi.PoModalComponent, { static: true },] }]
        };
        return MessageComponent;
    }());
    if (false) {
        /**
         * Atributo que recebe a referência do componente PoModalComponent no HTML
         * @type {?}
         */
        MessageComponent.prototype.poModal;
        /**
         * Atributo com o título da mensagem
         * @type {?}
         */
        MessageComponent.prototype.messageTitle;
        /**
         * Atributo com o texto da mensagem
         * @type {?}
         */
        MessageComponent.prototype.messageText;
        /**
         * Atributo com os detalhes da mensagem
         * @type {?}
         */
        MessageComponent.prototype.messageDetails;
        /**
         * Atributo que recebe a ação de confirmação
         * @type {?}
         */
        MessageComponent.prototype.messageConfirmAction;
        /**
         * Atributo que recebe a ação de cancelamento
         * @type {?}
         */
        MessageComponent.prototype.messageCancelAction;
        /**
         * Atributo que recebe o tipo do link
         * @type {?}
         */
        MessageComponent.prototype.messageLinkActionType;
        /**
         * Atributo que recebe o link
         * @type {?}
         */
        MessageComponent.prototype.messageLinkAction;
        /**
         * Atributo que recebe o label do link
         * @type {?}
         */
        MessageComponent.prototype.messageLinkLabel;
        /**
         * Atributo que indica se os detalhes da mensagem devem ser escondidos
         * @type {?}
         */
        MessageComponent.prototype.hideDetails;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Serviço de mensagens
     */
    var MessageService = /** @class */ (function (_super) {
        __extends(MessageService, _super);
        /**
         * Método construtor da classe
         * @param poNotification Parâmetro do serviço de notificação do Po
         * @param componentFactoryResolver Parâmetro do serviço que permite adicionar componentes dinamicamente
         * @param appRef Parâmetro que recebe a referência da aplicação Angular.
         * @param injector Parâmetro do serviço de injeção de dependência
         * @param i18n  Parâmetro do serviço de internacionalização
         */
        function MessageService(poNotification, componentFactoryResolver, appRef, injector, i18n) {
            var _this = _super.call(this) || this;
            _this.poNotification = poNotification;
            _this.componentFactoryResolver = componentFactoryResolver;
            _this.appRef = appRef;
            _this.injector = injector;
            _this.i18n = i18n;
            /**
             * Atributo que recebe a instância da dialog criada
             */
            _this.messageDialogRef = undefined;
            return _this;
        }
        /**
         * Método responsável por exibir uma mensagem, através de notificação ou dialog
         * @param showMessageOptions Parâmetro com as definições da mensagem
         */
        /**
         * Método responsável por exibir uma mensagem, através de notificação ou dialog
         * @param {?} showMessageOptions Parâmetro com as definições da mensagem
         * @return {?}
         */
        MessageService.prototype.displayMessage = /**
         * Método responsável por exibir uma mensagem, através de notificação ou dialog
         * @param {?} showMessageOptions Parâmetro com as definições da mensagem
         * @return {?}
         */
        function (showMessageOptions) {
            showMessageOptions = showMessageOptions;
            switch (showMessageOptions.messageType) {
                case totvsLogBaseFoundation.ShowMessageType.NotificationError:
                case totvsLogBaseFoundation.ShowMessageType.NotificationInformation:
                case totvsLogBaseFoundation.ShowMessageType.NotificationSuccess:
                case totvsLogBaseFoundation.ShowMessageType.NotificationWarning:
                    this.showNotification(showMessageOptions);
                    break;
                case totvsLogBaseFoundation.ShowMessageType.DialogAlert:
                case totvsLogBaseFoundation.ShowMessageType.DialogConfirmation:
                    this.showDialog(showMessageOptions);
                    break;
                default:
                    throw new Error("Tipo de mensagem inv\u00E1lido: " + showMessageOptions.messageType);
            }
        };
        /**
         * Método responsável por exibir uma notificação em tela
         * @param showMessageOptions Parâmetro com as definições da mensagem
         */
        /**
         * Método responsável por exibir uma notificação em tela
         * @private
         * @param {?} showMessageOptions Parâmetro com as definições da mensagem
         * @return {?}
         */
        MessageService.prototype.showNotification = /**
         * Método responsável por exibir uma notificação em tela
         * @private
         * @param {?} showMessageOptions Parâmetro com as definições da mensagem
         * @return {?}
         */
        function (showMessageOptions) {
            /** @type {?} */
            var poNotification = {
                message: showMessageOptions.messageText,
                orientation: portinariUi.PoToasterOrientation.Bottom,
                action: this.processLinkAction(showMessageOptions),
                actionLabel: showMessageOptions.messageLinkLabel
            };
            switch (showMessageOptions.messageType) {
                case totvsLogBaseFoundation.ShowMessageType.NotificationSuccess:
                    this.poNotification.success(poNotification);
                    break;
                case totvsLogBaseFoundation.ShowMessageType.NotificationError:
                    this.poNotification.error(poNotification);
                    break;
                case totvsLogBaseFoundation.ShowMessageType.NotificationInformation:
                    this.poNotification.information(poNotification);
                    break;
                case totvsLogBaseFoundation.ShowMessageType.NotificationWarning:
                    this.poNotification.warning(poNotification);
                    break;
            }
        };
        /**
         * Método por exibir uma dialog em tela
         * @param showMessageOptions Parâmetro com as definições da mensagem
         */
        /**
         * Método por exibir uma dialog em tela
         * @private
         * @param {?} showMessageOptions Parâmetro com as definições da mensagem
         * @return {?}
         */
        MessageService.prototype.showDialog = /**
         * Método por exibir uma dialog em tela
         * @private
         * @param {?} showMessageOptions Parâmetro com as definições da mensagem
         * @return {?}
         */
        function (showMessageOptions) {
            this.createDialogComponent();
            this.setDialogOptions(showMessageOptions);
            this.messageDialogRef.instance.openDialog();
        };
        /**
         * Método responsável por abrir no navegador uma nova tab com o link recebido por parâmetro
         * @param link Link de uma página externa
         */
        /**
         * Método responsável por abrir no navegador uma nova tab com o link recebido por parâmetro
         * @private
         * @param {?} link Link de uma página externa
         * @return {?}
         */
        MessageService.prototype.openLink = /**
         * Método responsável por abrir no navegador uma nova tab com o link recebido por parâmetro
         * @private
         * @param {?} link Link de uma página externa
         * @return {?}
         */
        function (link) {
            link = link.indexOf('http://') === -1 ? "http://" + link : link;
            window.open(link, '_blank');
        };
        /**
         * Método responsável por identificar se o link recebido é uma função ou página externa
         * @param showMessageOptions Parâmetro com as definições da mensagem
         */
        /**
         * Método responsável por identificar se o link recebido é uma função ou página externa
         * @private
         * @param {?} showMessageOptions Parâmetro com as definições da mensagem
         * @return {?}
         */
        MessageService.prototype.processLinkAction = /**
         * Método responsável por identificar se o link recebido é uma função ou página externa
         * @private
         * @param {?} showMessageOptions Parâmetro com as definições da mensagem
         * @return {?}
         */
        function (showMessageOptions) {
            var _this = this;
            /** @type {?} */
            var action;
            if (showMessageOptions.messageLinkActionType === totvsLogBaseFoundation.ShowMessageLinkActionType.Method) {
                action = showMessageOptions.messageLinkAction;
            }
            else if (showMessageOptions.messageLinkActionType === totvsLogBaseFoundation.ShowMessageLinkActionType.LinkNewTab &&
                showMessageOptions.messageLinkAction && showMessageOptions.messageLinkAction.trim() !== '') {
                action = (/**
                 * @return {?}
                 */
                function () {
                    _this.openLink(showMessageOptions.messageLinkAction);
                });
            }
            return action;
        };
        /**
         * Método responsável por criar o componente dialog
         */
        /**
         * Método responsável por criar o componente dialog
         * @private
         * @return {?}
         */
        MessageService.prototype.createDialogComponent = /**
         * Método responsável por criar o componente dialog
         * @private
         * @return {?}
         */
        function () {
            if (this.messageDialogRef === undefined) {
                this.messageDialogRef = this.componentFactoryResolver
                    .resolveComponentFactory(MessageComponent)
                    .create(this.injector);
                this.appRef.attachView(this.messageDialogRef.hostView);
                /** @type {?} */
                var domElem = (/** @type {?} */ (((/** @type {?} */ (this.messageDialogRef.hostView)))
                    .rootNodes[0]));
                document.body.appendChild(domElem);
            }
        };
        /**
         * Método responsável por setar as opções do componente dialog
         * @param showMessageOptions Parâmetro com as definições da mensagem
         */
        /**
         * Método responsável por setar as opções do componente dialog
         * @private
         * @param {?} showMessageOptions Parâmetro com as definições da mensagem
         * @return {?}
         */
        MessageService.prototype.setDialogOptions = /**
         * Método responsável por setar as opções do componente dialog
         * @private
         * @param {?} showMessageOptions Parâmetro com as definições da mensagem
         * @return {?}
         */
        function (showMessageOptions) {
            var _this = this;
            if (showMessageOptions.messageTitle !== undefined &&
                showMessageOptions.messageTitle.trim() !== '') {
                this.messageDialogRef.instance.messageTitle = showMessageOptions.messageTitle;
            }
            else if (showMessageOptions.messageType === totvsLogBaseFoundation.ShowMessageType.DialogAlert) {
                this.messageDialogRef.instance.messageTitle = this.i18n.literals.warning;
            }
            else if (showMessageOptions.messageType === totvsLogBaseFoundation.ShowMessageType.DialogConfirmation) {
                this.messageDialogRef.instance.messageTitle = this.i18n.literals.confirm;
            }
            this.messageDialogRef.instance.messageText = showMessageOptions.messageText;
            this.messageDialogRef.instance.messageDetails = showMessageOptions.messageDetails;
            this.messageDialogRef.instance.messageConfirmAction = {
                action: (/**
                 * @return {?}
                 */
                function () {
                    if (showMessageOptions.messageConfirmAction) {
                        showMessageOptions.messageConfirmAction();
                    }
                    _this.messageDialogRef.instance.closeDialog();
                }),
                label: showMessageOptions.messageConfirmLabel
            };
            this.messageDialogRef.instance.messageCancelAction = {
                action: (/**
                 * @return {?}
                 */
                function () {
                    if (showMessageOptions.messageCancelAction) {
                        showMessageOptions.messageCancelAction();
                    }
                    _this.messageDialogRef.instance.closeDialog();
                }),
                label: showMessageOptions.messageCancelLabel
            };
            this.messageDialogRef.instance.messageLinkActionType = showMessageOptions.messageLinkActionType;
            if (showMessageOptions.messageLinkActionType === totvsLogBaseFoundation.ShowMessageLinkActionType.LinkNewTab) {
                /** @type {?} */
                var link_1 = showMessageOptions.messageLinkAction;
                showMessageOptions.messageLinkAction = (/**
                 * @return {?}
                 */
                function () {
                    _this.openLink(link_1);
                });
            }
            this.messageDialogRef.instance.messageLinkAction = showMessageOptions.messageLinkAction;
            this.messageDialogRef.instance.messageLinkLabel = showMessageOptions.messageLinkLabel;
        };
        MessageService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        MessageService.ctorParameters = function () { return [
            { type: portinariUi.PoNotificationService },
            { type: core.ComponentFactoryResolver },
            { type: core.ApplicationRef },
            { type: core.Injector },
            { type: totvsLogBaseFoundation.I18nBaseService }
        ]; };
        return MessageService;
    }(totvsLogBaseFoundation.AbstractShowMessage));
    if (false) {
        /**
         * Atributo que recebe a instância da dialog criada
         * @type {?}
         * @private
         */
        MessageService.prototype.messageDialogRef;
        /**
         * @type {?}
         * @private
         */
        MessageService.prototype.poNotification;
        /**
         * @type {?}
         * @private
         */
        MessageService.prototype.componentFactoryResolver;
        /**
         * @type {?}
         * @private
         */
        MessageService.prototype.appRef;
        /**
         * @type {?}
         * @private
         */
        MessageService.prototype.injector;
        /**
         * @type {?}
         * @private
         */
        MessageService.prototype.i18n;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MessageModule = /** @class */ (function () {
        function MessageModule() {
        }
        MessageModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [MessageComponent],
                        imports: [
                            common.CommonModule,
                            portinariUi.PoModule
                        ],
                        exports: [],
                        providers: [
                            MessageService,
                            totvsLogBaseFoundation.MessageDisplayerService,
                            {
                                provide: totvsLogBaseFoundation.AbstractShowMessage,
                                useClass: MessageService
                            }
                        ]
                    },] }
        ];
        return MessageModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ChangeLanguageComponent = /** @class */ (function () {
        function ChangeLanguageComponent(i18n) {
            this.i18n = i18n;
            this.literals = {
                modalTitle: 'changeLanguage',
                radioGroupLabel: 'selectLanguage',
                saveAction: 'save',
                cancelAction: 'cancel'
            };
            this.afterChangeLanguage = new core.EventEmitter();
            this._languageOptions = [];
        }
        Object.defineProperty(ChangeLanguageComponent.prototype, "primaryAction", {
            get: /**
             * @return {?}
             */
            function () {
                return this._primaryAction;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ChangeLanguageComponent.prototype, "secondaryAction", {
            get: /**
             * @return {?}
             */
            function () {
                return this._secondaryAction;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ChangeLanguageComponent.prototype, "languageOptions", {
            get: /**
             * @return {?}
             */
            function () {
                return this._languageOptions;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ChangeLanguageComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () { };
        /**
         * @return {?}
         */
        ChangeLanguageComponent.prototype.openChangeLanguageModal = /**
         * @return {?}
         */
        function () {
            this.setModalActions();
            this.setLanguageOptions();
            this.selectedLanguage = this.i18n.getLanguage();
            this.changeLanguageModal.open();
        };
        /**
         * @private
         * @return {?}
         */
        ChangeLanguageComponent.prototype.setModalActions = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            this._primaryAction = {
                label: this.i18n.literals[this.literals.saveAction],
                action: (/**
                 * @return {?}
                 */
                function () {
                    _this.changeLanguage();
                })
            };
            this._secondaryAction = {
                label: this.i18n.literals[this.literals.cancelAction],
                action: (/**
                 * @return {?}
                 */
                function () {
                    _this.changeLanguageModal.close();
                })
            };
        };
        /**
         * @private
         * @return {?}
         */
        ChangeLanguageComponent.prototype.setLanguageOptions = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            this._languageOptions = [];
            this.i18n.getSupportedLanguages().forEach((/**
             * @param {?} supportedLanguage
             * @return {?}
             */
            function (supportedLanguage) {
                _this._languageOptions.push({
                    label: _this.i18n.literals[supportedLanguage.language],
                    value: supportedLanguage.language
                });
            }));
        };
        /**
         * @private
         * @return {?}
         */
        ChangeLanguageComponent.prototype.changeLanguage = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var subscribe = this.i18n.updateOptions({ language: this.selectedLanguage }).subscribe((/**
             * @return {?}
             */
            function () {
                _this.afterChangeLanguage.emit(_this.selectedLanguage);
                _this.changeLanguageModal.close();
            }), (/**
             * @return {?}
             */
            function () { }), (/**
             * @return {?}
             */
            function () {
                subscribe.unsubscribe();
            }));
        };
        ChangeLanguageComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-change-language',
                        template: "<po-modal #changeLanguageModal\n  [p-title]=\"i18n.literals[literals.modalTitle]\"\n  p-click-out=\"true\"\n  p-size=\"sm\"\n  [p-primary-action]=\"primaryAction\"\n  [p-secondary-action]=\"secondaryAction\">\n  <po-radio-group\n    name=\"radioGroupLanguage\"\n    [(ngModel)]=\"selectedLanguage\"\n    [p-label]=\"i18n.literals[literals.radioGroupLabel]\"\n    [p-options]=\"languageOptions\"\n    p-required\n    p-columns=\"1\">\n  </po-radio-group>\n</po-modal>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        ChangeLanguageComponent.ctorParameters = function () { return [
            { type: totvsLogBaseFoundation.I18nBaseService }
        ]; };
        ChangeLanguageComponent.propDecorators = {
            literals: [{ type: core.Input }],
            afterChangeLanguage: [{ type: core.Output }],
            changeLanguageModal: [{ type: core.ViewChild, args: [portinariUi.PoModalComponent, { static: true },] }]
        };
        return ChangeLanguageComponent;
    }());
    if (false) {
        /** @type {?} */
        ChangeLanguageComponent.prototype.literals;
        /** @type {?} */
        ChangeLanguageComponent.prototype.afterChangeLanguage;
        /** @type {?} */
        ChangeLanguageComponent.prototype.changeLanguageModal;
        /**
         * @type {?}
         * @private
         */
        ChangeLanguageComponent.prototype._primaryAction;
        /**
         * @type {?}
         * @private
         */
        ChangeLanguageComponent.prototype._secondaryAction;
        /**
         * @type {?}
         * @private
         */
        ChangeLanguageComponent.prototype._languageOptions;
        /** @type {?} */
        ChangeLanguageComponent.prototype.selectedLanguage;
        /** @type {?} */
        ChangeLanguageComponent.prototype.i18n;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var IntlModule = /** @class */ (function () {
        function IntlModule() {
        }
        IntlModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            forms.FormsModule,
                            portinariUi.PoModalModule,
                            portinariUi.PoComponentsModule,
                            portinariUi.PoI18nModule.config(IntlService.i18nConfig)
                        ],
                        exports: [
                            portinariUi.PoI18nModule,
                            ChangeLanguageComponent
                        ],
                        providers: [
                            IntlService,
                            IntlLiteralsLoaderService,
                            {
                                provide: totvsLogBaseFoundation.I18nBaseService,
                                useClass: IntlService
                            }
                        ],
                        declarations: [
                            ChangeLanguageComponent
                        ]
                    },] }
        ];
        return IntlModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LoadingComponent = /** @class */ (function () {
        function LoadingComponent() {
            /**
             * Texto do loading
             */
            this.text = '';
            /**
             * Definine se será bloqueada a tela inteira ou apenas o container em que o componente de loading está inserido
             */
            this.screenLock = false;
            /**
             * Define se o loading está sendo mostrado ou não
             */
            this.show = false;
        }
        /**
         * Permite atribuir o texto do loading
         */
        /**
         * Permite atribuir o texto do loading
         * @param {?=} text
         * @return {?}
         */
        LoadingComponent.prototype.setLoadingText = /**
         * Permite atribuir o texto do loading
         * @param {?=} text
         * @return {?}
         */
        function (text) {
            if (text === void 0) { text = ''; }
            this.text = text;
        };
        /**
         * Apresenta o loading, bloqueando a tela
         */
        /**
         * Apresenta o loading, bloqueando a tela
         * @return {?}
         */
        LoadingComponent.prototype.showLoading = /**
         * Apresenta o loading, bloqueando a tela
         * @return {?}
         */
        function () {
            this.show = true;
        };
        /**
         * Esconde o loading, desbloqueando a tela
         */
        /**
         * Esconde o loading, desbloqueando a tela
         * @return {?}
         */
        LoadingComponent.prototype.hideLoading = /**
         * Esconde o loading, desbloqueando a tela
         * @return {?}
         */
        function () {
            this.show = false;
        };
        LoadingComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-loading',
                        template: "<po-loading-overlay\n    *ngIf=\"show\"\n    [p-screen-lock]=\"screenLock\"\n    [p-text]=\"text\">\n</po-loading-overlay>",
                        styles: [""]
                    }] }
        ];
        return LoadingComponent;
    }());
    if (false) {
        /**
         * Texto do loading
         * @type {?}
         */
        LoadingComponent.prototype.text;
        /**
         * Definine se será bloqueada a tela inteira ou apenas o container em que o componente de loading está inserido
         * @type {?}
         */
        LoadingComponent.prototype.screenLock;
        /**
         * Define se o loading está sendo mostrado ou não
         * @type {?}
         */
        LoadingComponent.prototype.show;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LoadingService = /** @class */ (function (_super) {
        __extends(LoadingService, _super);
        /**
         * Construtor do serviço
         * @param i18n Serviço de internacionalização
         * @param componentFactoryResolver Serviço que permite adicionar componentes dinamicamente
         * @param appRef Referência da aplicação Angular
         * @param injector Serviço de injeção de dependência
         */
        function LoadingService(i18n, componentFactoryResolver, appRef, injector) {
            var _this = _super.call(this) || this;
            _this.i18n = i18n;
            _this.componentFactoryResolver = componentFactoryResolver;
            _this.appRef = appRef;
            _this.injector = injector;
            /**
             * Referência para o componente de loading no html
             */
            _this.loadingComponentRef = undefined;
            /**
             * Texto apresentado durante o loading
             */
            _this.loadingText = '';
            return _this;
        }
        /**
         * Exibe o loading, bloqueando a tela
         */
        /**
         * Exibe o loading, bloqueando a tela
         * @return {?}
         */
        LoadingService.prototype.showLoading = /**
         * Exibe o loading, bloqueando a tela
         * @return {?}
         */
        function () {
            if (this.loadingComponentRef === undefined) {
                this.createLoadingComponent();
            }
            this.loadingComponentRef.instance.showLoading();
        };
        /**
         * Esconde o loading, desbloqueando a tela
         */
        /**
         * Esconde o loading, desbloqueando a tela
         * @return {?}
         */
        LoadingService.prototype.hideLoading = /**
         * Esconde o loading, desbloqueando a tela
         * @return {?}
         */
        function () {
            if (this.loadingComponentRef !== undefined) {
                this.loadingComponentRef.instance.hideLoading();
            }
        };
        /**
         * Atribui o texto que será apresentado
         * @param text Texto a ser apresentado, devendo ser um BaseMessage
         */
        /**
         * Atribui o texto que será apresentado
         * @param {?} text Texto a ser apresentado, devendo ser um BaseMessage
         * @return {?}
         */
        LoadingService.prototype.setLoadingText = /**
         * Atribui o texto que será apresentado
         * @param {?} text Texto a ser apresentado, devendo ser um BaseMessage
         * @return {?}
         */
        function (text) {
            this.loadingText = this.i18n.text(text) ? this.i18n.text(text).text : '';
            if (this.loadingComponentRef === undefined) {
                this.createLoadingComponent();
            }
            this.loadingComponentRef.instance.text = this.loadingText;
        };
        /**
         * Método privado que cria dinamicamente o componente de loading no DOM
         */
        /**
         * Método privado que cria dinamicamente o componente de loading no DOM
         * @private
         * @return {?}
         */
        LoadingService.prototype.createLoadingComponent = /**
         * Método privado que cria dinamicamente o componente de loading no DOM
         * @private
         * @return {?}
         */
        function () {
            if (this.loadingComponentRef === undefined) {
                this.loadingComponentRef = this.componentFactoryResolver
                    .resolveComponentFactory(LoadingComponent)
                    .create(this.injector);
                this.appRef.attachView(this.loadingComponentRef.hostView);
                /** @type {?} */
                var domElem = (/** @type {?} */ (((/** @type {?} */ (this.loadingComponentRef.hostView)))
                    .rootNodes[0]));
                document.body.appendChild(domElem);
            }
        };
        LoadingService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        LoadingService.ctorParameters = function () { return [
            { type: totvsLogBaseFoundation.I18nBaseService },
            { type: core.ComponentFactoryResolver },
            { type: core.ApplicationRef },
            { type: core.Injector }
        ]; };
        return LoadingService;
    }(totvsLogBaseFoundation.LoadingDefault));
    if (false) {
        /**
         * Referência para o componente de loading no html
         * @type {?}
         * @private
         */
        LoadingService.prototype.loadingComponentRef;
        /**
         * Texto apresentado durante o loading
         * @type {?}
         * @private
         */
        LoadingService.prototype.loadingText;
        /**
         * @type {?}
         * @private
         */
        LoadingService.prototype.i18n;
        /**
         * @type {?}
         * @private
         */
        LoadingService.prototype.componentFactoryResolver;
        /**
         * @type {?}
         * @private
         */
        LoadingService.prototype.appRef;
        /**
         * @type {?}
         * @private
         */
        LoadingService.prototype.injector;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Serviço responsável por métodos e atributos utilizados por toda aplicação web
     */
    var GlobalService = /** @class */ (function () {
        /**
         * Método construtor que inicializa a classe
         * @param i18n Parâmetro do serviço de internacionalização
         * @param msg  Parâmetro do serviço de mensagens
         * @param loading Parâmetro do serviço de loading
         */
        function GlobalService(i18n, msg, loading) {
            this.i18n = i18n;
            this.msg = msg;
            this.loading = loading;
        }
        GlobalService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        GlobalService.ctorParameters = function () { return [
            { type: totvsLogBaseFoundation.I18nBaseService },
            { type: totvsLogBaseFoundation.MessageDisplayerService },
            { type: LoadingService }
        ]; };
        return GlobalService;
    }());
    if (false) {
        /** @type {?} */
        GlobalService.prototype.i18n;
        /** @type {?} */
        GlobalService.prototype.msg;
        /** @type {?} */
        GlobalService.prototype.loading;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LoadingModule = /** @class */ (function () {
        function LoadingModule() {
        }
        LoadingModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [LoadingComponent],
                        imports: [
                            common.CommonModule,
                            portinariUi.PoModule
                        ],
                        exports: [],
                        providers: [
                            LoadingService
                        ]
                    },] }
        ];
        return LoadingModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var i18nFactory = (/**
     * @param {?} i18n
     * @param {?} config
     * @return {?}
     */
    function (i18n, config) {
        return (/**
         * @return {?}
         */
        function () { return new Promise((/**
         * @param {?} resolve
         * @return {?}
         */
        function (resolve) {
            if (config.lazy) {
                resolve(true);
            }
            else {
                i18n.updateOptions({}).subscribe((/**
                 * @return {?}
                 */
                function () {
                    resolve(true);
                }), (/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) {
                    console.error(error);
                    resolve(false);
                }));
            }
        })); });
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Módulo que exporta e ativas as dependências basicas do foundation
     * Para garantir que os serviços tenham uma única instância, usar FndModule.forRoot() ao importar
     */
    var FndModule = /** @class */ (function () {
        function FndModule() {
        }
        /**
         * @return {?}
         */
        FndModule.forRoot = /**
         * @return {?}
         */
        function () {
            return {
                ngModule: FndModule,
                providers: [
                    GlobalService,
                    {
                        provide: core.APP_INITIALIZER,
                        useFactory: i18nFactory,
                        deps: [totvsLogBaseFoundation.I18nBaseService, INTL_CONFIG],
                        multi: true
                    }
                ]
            };
        };
        FndModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            portinariUi.PoModule,
                            IntlModule,
                            MessageModule,
                            totvsLogBaseFoundation.DateTimeModule,
                            LoadingModule
                        ],
                        exports: [
                            IntlModule,
                            MessageModule,
                            totvsLogBaseFoundation.DateTimeModule,
                            LoadingModule
                        ],
                        entryComponents: [MessageComponent, LoadingComponent]
                    },] }
        ];
        return FndModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Representa um componente para aceitar o redirecionamento de callback do fluxo de oauth2
     */
    var AuthCallbackComponent = /** @class */ (function () {
        /**
         * Creates an instance of AuthCallbackComponent.
         */
        function AuthCallbackComponent(router$1, authService) {
            var _this = this;
            this.router = router$1;
            this.authService = authService;
            this.router.events.forEach((/**
             * @param {?} event
             * @return {?}
             */
            function (event) {
                if (event instanceof router.NavigationEnd) {
                    _this.authService
                        .completeAuthentication()
                        .then((/**
                     * @return {?}
                     */
                    function () {
                        _this.authService
                            .getUser()
                            .then((/**
                         * @param {?} user
                         * @return {?}
                         */
                        function (user) {
                            _this.authService.userLoadedEvent.emit(user);
                        }));
                    }));
                }
            }));
        }
        /**
         * @return {?}
         */
        AuthCallbackComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        AuthCallbackComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-auth-callback',
                        template: ''
                    }] }
        ];
        /** @nocollapse */
        AuthCallbackComponent.ctorParameters = function () { return [
            { type: router.Router },
            { type: totvsLogBaseFoundation.AuthBaseService }
        ]; };
        return AuthCallbackComponent;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        AuthCallbackComponent.prototype.router;
        /**
         * @type {?}
         * @private
         */
        AuthCallbackComponent.prototype.authService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Implementação de guard com uso do serviço de autenticação padrão
     */
    var AuthGuard = /** @class */ (function () {
        /**
         * Creates an instance of AuthGuard.
         */
        function AuthGuard(authService) {
            this.authService = authService;
        }
        /**
         * Implementação do serviço angular que previne o carregamento de componentes, se necessário
         */
        /**
         * Implementação do serviço angular que previne o carregamento de componentes, se necessário
         * @return {?}
         */
        AuthGuard.prototype.canActivate = /**
         * Implementação do serviço angular que previne o carregamento de componentes, se necessário
         * @return {?}
         */
        function () {
            return __awaiter(this, void 0, void 0, function () {
                var isAuthorized, user;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.authService.authorize()];
                        case 1:
                            isAuthorized = _a.sent();
                            if (!isAuthorized) return [3 /*break*/, 3];
                            return [4 /*yield*/, this.authService.getUser()];
                        case 2:
                            user = _a.sent();
                            this.authService.userLoadedEvent.next(user);
                            _a.label = 3;
                        case 3: return [2 /*return*/, isAuthorized];
                    }
                });
            });
        };
        AuthGuard.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        AuthGuard.ctorParameters = function () { return [
            { type: totvsLogBaseFoundation.AuthBaseService }
        ]; };
        return AuthGuard;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        AuthGuard.prototype.authService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AuthService = /** @class */ (function (_super) {
        __extends(AuthService, _super);
        /**
         * Método construtor da classe
         * @param authSettings Token de injeção com as configurações de autenticação
         * @param authType Token de injeção com o tipo de autenticação
         */
        function AuthService(authSettings, authType) {
            var _this = _super.call(this, AuthService.AddOriginUrls(authSettings)) || this;
            _this.authSettings = authSettings;
            _this.authType = authType;
            if (_this.authSettings === undefined) {
                throw new totvsLogBaseFoundation.CriticalError('authSettings: undefined');
            }
            if (_this.authType === undefined) {
                throw new totvsLogBaseFoundation.CriticalError('authType: undefined');
            }
            return _this;
        }
        /**
         * Adiciona nas uris de redirecionamento do processo oauth o host de origem, se um host não for informado
         * Isso é para permitir que o navegador identifique o domínio de redirecionamento
         * utilizando o caminho relativo
         *
         * @param authSettings as configurações de autenticação
         * @returns as configurações de autenticação com uris normalizadas para o processo de autenticação
         */
        /**
         * Adiciona nas uris de redirecionamento do processo oauth o host de origem, se um host não for informado
         * Isso é para permitir que o navegador identifique o domínio de redirecionamento
         * utilizando o caminho relativo
         *
         * @param {?} authSettings as configurações de autenticação
         * @return {?} as configurações de autenticação com uris normalizadas para o processo de autenticação
         */
        AuthService.AddOriginUrls = /**
         * Adiciona nas uris de redirecionamento do processo oauth o host de origem, se um host não for informado
         * Isso é para permitir que o navegador identifique o domínio de redirecionamento
         * utilizando o caminho relativo
         *
         * @param {?} authSettings as configurações de autenticação
         * @return {?} as configurações de autenticação com uris normalizadas para o processo de autenticação
         */
        function (authSettings) {
            if (authSettings) {
                authSettings.redirect_uri = AuthService.AddOriginUrl(window.location.origin, authSettings.redirect_uri);
                authSettings.post_logout_redirect_uri
                    = AuthService.AddOriginUrl(window.location.origin, authSettings.post_logout_redirect_uri);
                authSettings.silent_redirect_uri = AuthService.AddOriginUrl(window.location.origin, authSettings.silent_redirect_uri);
                if (!authSettings.post_logout_redirect_uri) {
                    authSettings.post_logout_redirect_uri = window.location.origin;
                }
            }
            return authSettings;
        };
        /**
         * Adiciona o host na url, se nenhum host estiver presente
         * @param host o host a ser adicionado
         * @param url url em que o host será adicionado
         * @returns a junção da url e host
         */
        /**
         * Adiciona o host na url, se nenhum host estiver presente
         * @param {?} host o host a ser adicionado
         * @param {?} url url em que o host será adicionado
         * @return {?} a junção da url e host
         */
        AuthService.AddOriginUrl = /**
         * Adiciona o host na url, se nenhum host estiver presente
         * @param {?} host o host a ser adicionado
         * @param {?} url url em que o host será adicionado
         * @return {?} a junção da url e host
         */
        function (host, url) {
            if (url.trim().length !== 0 && !url.startsWith(host) && !url.startsWith('http')) {
                url = "" + host + url;
            }
            return url;
        };
        /**
         * Verifica se está em atuação o fluxo de login e deveria ou não mostrar o menu
         */
        /**
         * Verifica se está em atuação o fluxo de login e deveria ou não mostrar o menu
         * @param {?} router
         * @return {?}
         */
        AuthService.prototype.shouldShowMenu = /**
         * Verifica se está em atuação o fluxo de login e deveria ou não mostrar o menu
         * @param {?} router
         * @return {?}
         */
        function (router$1) {
            /** @type {?} */
            var loginFlow = false;
            router$1.events.forEach((/**
             * @param {?} event
             * @return {?}
             */
            function (event) {
                if (event instanceof router.NavigationStart) {
                    loginFlow = event.url === '' || event.url === '/' || event.url.startsWith('/auth-callback');
                    // vai redirecionar, guarda a rota atual
                    if (!loginFlow) {
                        localStorage.setItem('current.route', event.url);
                    }
                }
            }));
            return loginFlow;
        };
        /**
         * Monta um PoToolbarProfile a partir do usuário. Sem suporte a avatar no momento
         */
        /**
         * Monta um PoToolbarProfile a partir do usuário. Sem suporte a avatar no momento
         * @param {?} user
         * @return {?}
         */
        AuthService.prototype.getToolbarProfile = /**
         * Monta um PoToolbarProfile a partir do usuário. Sem suporte a avatar no momento
         * @param {?} user
         * @return {?}
         */
        function (user) {
            return {
                title: user && user.profile ? user.profile.name : null,
                subtitle: user && user.profile ? user.profile.email : null
            };
        };
        /**
         * Método responsável executar o processo de login/autenticação
         */
        /**
         * Método responsável executar o processo de login/autenticação
         * @return {?}
         */
        AuthService.prototype.loginFlow = /**
         * Método responsável executar o processo de login/autenticação
         * @return {?}
         */
        function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.authType.type === totvsLogBaseFoundation.AuthHandlerType.oauth2)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.signinRedirect()];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * Método responsável executar o processo de logout
         */
        /**
         * Método responsável executar o processo de logout
         * @return {?}
         */
        AuthService.prototype.logoutFlow = /**
         * Método responsável executar o processo de logout
         * @return {?}
         */
        function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.authType.type === totvsLogBaseFoundation.AuthHandlerType.oauth2)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.signoutRedirect()];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2: return [2 /*return*/];
                    }
                });
            });
        };
        AuthService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        AuthService.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [totvsLogBaseFoundation.AUTH_SETTINGS,] }] },
            { type: undefined, decorators: [{ type: core.Inject, args: [totvsLogBaseFoundation.AUTH_TYPE,] }] }
        ]; };
        return AuthService;
    }(totvsLogBaseFoundation.AuthBaseService));
    if (false) {
        /**
         * @type {?}
         * @private
         */
        AuthService.prototype.authSettings;
        /**
         * @type {?}
         * @private
         */
        AuthService.prototype.authType;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Módulo que exporta e ativas as dependências para utilizar autenticação com fluxo oauth2
     * Para garantir que os serviços tenham uma única instância, usar AuthModule.forRoot() ao importar
     */
    var AuthModule = /** @class */ (function () {
        function AuthModule() {
        }
        /**
         * @return {?}
         */
        AuthModule.forRoot = /**
         * @return {?}
         */
        function () {
            return {
                ngModule: AuthModule,
                providers: [
                    AuthService,
                    totvsLogBaseFoundation.UserPermissionService,
                    {
                        provide: totvsLogBaseFoundation.AuthBaseService,
                        useClass: AuthService
                    },
                    AuthGuard
                ]
            };
        };
        AuthModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [],
                        exports: [],
                        entryComponents: [],
                        providers: [
                            {
                                provide: http.HTTP_INTERCEPTORS,
                                useClass: totvsLogBaseFoundation.AuthInterceptorHandlerService,
                                multi: true
                            }
                        ],
                        declarations: [AuthCallbackComponent]
                    },] }
        ];
        return AuthModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     * @template T
     */
    var   /**
     * @abstract
     * @template T
     */
    Enum = /** @class */ (function () {
        function Enum(value, label, disabled) {
            if (disabled === void 0) { disabled = false; }
            this.value = value;
            this.label = label;
            this.disabled = disabled;
        }
        /**
         * @param {?} global
         * @return {?}
         */
        Enum.prototype.toRadio = /**
         * @param {?} global
         * @return {?}
         */
        function (global) {
            return { value: this.value + '', label: global.i18n.literals[this.label], disabled: this.disabled };
        };
        /**
         * @param {?} global
         * @return {?}
         */
        Enum.prototype.toCombo = /**
         * @param {?} global
         * @return {?}
         */
        function (global) {
            return { value: this.value + '', label: global.i18n.literals[this.label] };
        };
        /**
         * @param {?} global
         * @return {?}
         */
        Enum.prototype.toSelect = /**
         * @param {?} global
         * @return {?}
         */
        function (global) {
            return { value: this.value + '', label: global.i18n.literals[this.label] };
        };
        /**
         * @param {?} global
         * @return {?}
         */
        Enum.prototype.translateLabel = /**
         * @param {?} global
         * @return {?}
         */
        function (global) {
            return global.i18n.literals[this.label];
        };
        return Enum;
    }());
    if (false) {
        /** @type {?} */
        Enum.prototype.value;
        /** @type {?} */
        Enum.prototype.label;
        /** @type {?} */
        Enum.prototype.disabled;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var UnidadeFederativa = {
        'AC': 'Acre',
        'AL': 'Alagoas',
        'AP': 'Amapá',
        'AM': 'Amazonas',
        'BA': 'Bahia',
        'CE': 'Ceará',
        'DF': 'Distrito Federal',
        'ES': 'Espírito Santo',
        'GO': 'Goiás',
        'MA': 'Maranhão',
        'MT': 'Mato Grosso',
        'MS': 'Mato Grosso do Sul',
        'MG': 'Minas Gerais',
        'PA': 'Pará',
        'PB': 'Paraíba',
        'PR': 'Paraná',
        'PE': 'Pernambuco',
        'PI': 'Piauí',
        'RJ': 'Rio de Janeiro',
        'RN': 'Rio Grande do Norte',
        'RS': 'Rio Grande do Sul',
        'RO': 'Rondônia',
        'RR': 'Roraima',
        'SC': 'Santa Catarina',
        'SP': 'São Paulo',
        'SE': 'Sergipe',
        'TO': 'Tocantins',
        'EX': 'Exterior',
    };
    /** @type {?} */
    var opcoesUFThfCombo = (/**
     * @return {?}
     */
    function () {
        return Object.entries(UnidadeFederativa).map((/**
         * @param {?} x
         * @return {?}
         */
        function (x) { return ({
            label: x[1],
            value: x[0]
        }); }));
    });
    /** @type {?} */
    var opcoesUFThfSelect = (/**
     * @return {?}
     */
    function () { return opcoesUFThfCombo(); });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MessageWithWarningComponent = /** @class */ (function () {
        function MessageWithWarningComponent(global) {
            this.global = global;
            /**
             * Evento disparado na confirmação da operação na modal
             */
            this.confirm = new core.EventEmitter();
            /**
             * Evento disparado no cancelamento da operação na modal
             */
            this.cancel = new core.EventEmitter();
            /**
             * Tamanho da janela que será apresentada para o usuário.
             */
            this._modalSize = 'md';
            /**
             * Variável que indica se o fechamento da modal é controlado manualmente pelo programador
             */
            this.closeManually = false;
        }
        Object.defineProperty(MessageWithWarningComponent.prototype, "message", {
            /** Método acessor que retorna a mensagem que deve ser apresentada */
            get: /**
             * Método acessor que retorna a mensagem que deve ser apresentada
             * @return {?}
             */
            function () {
                return this._message;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MessageWithWarningComponent.prototype, "modalSize", {
            /** Método acessor que retorna o tamanho da janela que será apresentada para o usuário */
            get: /**
             * Método acessor que retorna o tamanho da janela que será apresentada para o usuário
             * @return {?}
             */
            function () {
                return this._modalSize;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MessageWithWarningComponent.prototype, "primaryAction", {
            get: /**
             * @return {?}
             */
            function () {
                return this._primaryAction;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MessageWithWarningComponent.prototype, "secondaryAction", {
            get: /**
             * @return {?}
             */
            function () {
                return this._secondaryAction;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Define a ação secundária para a modal
         */
        /**
         * Define a ação secundária para a modal
         * @private
         * @return {?}
         */
        MessageWithWarningComponent.prototype.setSecondaryAction = /**
         * Define a ação secundária para a modal
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            this._secondaryAction = {
                label: this.global.i18n.literals.nao,
                action: (/**
                 * @return {?}
                 */
                function () {
                    _this.cancel.emit(true);
                    if (!_this.closeManually) {
                        _this.modal.close();
                    }
                })
            };
        };
        /**
         * Define a ação primária para a modal
         */
        /**
         * Define a ação primária para a modal
         * @private
         * @return {?}
         */
        MessageWithWarningComponent.prototype.setPrimaryAction = /**
         * Define a ação primária para a modal
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            this._primaryAction = {
                label: this.global.i18n.literals.sim,
                action: (/**
                 * @return {?}
                 */
                function () {
                    _this.confirm.emit(true);
                    if (!_this.closeManually) {
                        _this.modal.close();
                    }
                })
            };
        };
        /**
         * Abre a modal com a mensagem
         * @param message Mensagem que pode ser passada com strings ou literais
         * @param closeManually Indicação se o controle do fechamento da modal deve ser manual
         * (programador precisa disparar o comando nos eventos de confirmação/cancelamento)
         */
        /**
         * Abre a modal com a mensagem
         * @param {?} message Mensagem que pode ser passada com strings ou literais
         * @param {?=} closeManually Indicação se o controle do fechamento da modal deve ser manual
         * (programador precisa disparar o comando nos eventos de confirmação/cancelamento)
         * @param {?=} modalSize
         * @return {?}
         */
        MessageWithWarningComponent.prototype.open = /**
         * Abre a modal com a mensagem
         * @param {?} message Mensagem que pode ser passada com strings ou literais
         * @param {?=} closeManually Indicação se o controle do fechamento da modal deve ser manual
         * (programador precisa disparar o comando nos eventos de confirmação/cancelamento)
         * @param {?=} modalSize
         * @return {?}
         */
        function (message, closeManually, modalSize) {
            if (closeManually === void 0) { closeManually = false; }
            if (modalSize === void 0) { modalSize = 'md'; }
            this.setSecondaryAction();
            this.setPrimaryAction();
            this.closeManually = closeManually;
            this._modalSize = modalSize;
            if (message instanceof totvsLogBaseFoundation.BaseMessage) {
                this._message = message.messageI18n(this.global.i18n);
            }
            else {
                this._message = message;
            }
            this.modal.open();
        };
        MessageWithWarningComponent.decorators = [
            { type: core.Component, args: [{
                        // tslint:disable-next-line:component-selector
                        selector: 'fnd-message-with-warning',
                        template: "<po-modal\n    p-click-out=\"true\"\n    [p-primary-action]=\"primaryAction\"\n    [p-secondary-action]=\"secondaryAction\"\n    [p-title]=\"message?.titleText\"\n    [p-size]=\"modalSize\">\n    <p\n        *ngIf=\"message?.text\"\n        class=\"po-font-text\">\n        {{ message.text }}\n    </p>\n    <p\n        *ngIf=\"message?.detailText\"\n        class=\"po-font-text-bold po-text-color-07 po-mt-1\">\n        {{ message.detailText }}\n    </p>\n</po-modal>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        MessageWithWarningComponent.ctorParameters = function () { return [
            { type: GlobalService }
        ]; };
        MessageWithWarningComponent.propDecorators = {
            confirm: [{ type: core.Output }],
            cancel: [{ type: core.Output }],
            modal: [{ type: core.ViewChild, args: [portinariUi.PoModalComponent, { static: true },] }]
        };
        return MessageWithWarningComponent;
    }());
    if (false) {
        /**
         * Evento disparado na confirmação da operação na modal
         * @type {?}
         */
        MessageWithWarningComponent.prototype.confirm;
        /**
         * Evento disparado no cancelamento da operação na modal
         * @type {?}
         */
        MessageWithWarningComponent.prototype.cancel;
        /**
         * Mensagem que será apresentada
         * @type {?}
         * @private
         */
        MessageWithWarningComponent.prototype._message;
        /**
         * Tamanho da janela que será apresentada para o usuário.
         * @type {?}
         * @private
         */
        MessageWithWarningComponent.prototype._modalSize;
        /**
         * Variável que indica se o fechamento da modal é controlado manualmente pelo programador
         * @type {?}
         * @private
         */
        MessageWithWarningComponent.prototype.closeManually;
        /**
         * Ação primária Confirmar
         * @type {?}
         * @private
         */
        MessageWithWarningComponent.prototype._primaryAction;
        /**
         * Ação secundária Cancelar
         * @type {?}
         * @private
         */
        MessageWithWarningComponent.prototype._secondaryAction;
        /**
         * Referência para a modal
         * @type {?}
         */
        MessageWithWarningComponent.prototype.modal;
        /** @type {?} */
        MessageWithWarningComponent.prototype.global;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MessageWithWarningModule = /** @class */ (function () {
        function MessageWithWarningModule() {
        }
        MessageWithWarningModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            MessageWithWarningComponent
                        ],
                        imports: [
                            common.CommonModule,
                            portinariUi.PoModalModule
                        ],
                        exports: [
                            MessageWithWarningComponent
                        ]
                    },] }
        ];
        return MessageWithWarningModule;
    }());

    exports.AuthCallbackComponent = AuthCallbackComponent;
    exports.AuthGuard = AuthGuard;
    exports.AuthModule = AuthModule;
    exports.AuthService = AuthService;
    exports.ChangeLanguageComponent = ChangeLanguageComponent;
    exports.Enum = Enum;
    exports.FndModule = FndModule;
    exports.GlobalService = GlobalService;
    exports.INTL_CONFIG = INTL_CONFIG;
    exports.IntlLiteralsLoaderService = IntlLiteralsLoaderService;
    exports.IntlModule = IntlModule;
    exports.IntlService = IntlService;
    exports.LoadingComponent = LoadingComponent;
    exports.LoadingModule = LoadingModule;
    exports.LoadingService = LoadingService;
    exports.MessageComponent = MessageComponent;
    exports.MessageModule = MessageModule;
    exports.MessageService = MessageService;
    exports.MessageWithWarningComponent = MessageWithWarningComponent;
    exports.MessageWithWarningModule = MessageWithWarningModule;
    exports.UnidadeFederativa = UnidadeFederativa;
    exports.i18nFactory = i18nFactory;
    exports.opcoesUFThfCombo = opcoesUFThfCombo;
    exports.opcoesUFThfSelect = opcoesUFThfSelect;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=totvs-log-web-foundation.umd.js.map
