import { PoComboOption, PoRadioGroupOption, PoSelectOption } from '@portinari/portinari-ui';
import { GlobalService } from './../global/global.service';
export declare abstract class Enum<T> {
    readonly value: T;
    readonly label: string;
    readonly disabled: boolean;
    protected constructor(value: T, label: string, disabled?: boolean);
    toRadio(global: GlobalService): PoRadioGroupOption;
    toCombo(global: GlobalService): PoComboOption;
    toSelect(global: GlobalService): PoSelectOption;
    translateLabel(global: GlobalService): string;
}
