import { OnInit } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { ActivatedRoute, Router } from '@angular/router';
import { PoBreadcrumb, PoInputComponent, PoPageAction, PoSelectOption } from '@portinari/portinari-ui';
import { UnidadeIncluirService } from 'totvs-log-base-foundation/src/sl-unidade';
import { GlobalService, UnidadeFederativa } from 'totvs-log-web-foundation';
import { UnidadeIncluirForm } from './unidade-incluir.form';
export declare class UnidadeIncluirComponent implements OnInit {
    global: GlobalService;
    private readonly router;
    private readonly activatedRoute;
    private readonly unidadeIncluirService;
    esconderBotaoCancelar: boolean;
    rotaAposAcoes: string;
    inscricaoEstadual: PoInputComponent;
    private _acoesPagina;
    readonly acoesPagina: PoPageAction[];
    private _itensBreadcrumb;
    readonly itensBreadcrumb: PoBreadcrumb;
    private _form;
    readonly form: UnidadeIncluirForm;
    private _opcoesEstado;
    readonly opcoesEstado: PoSelectOption[];
    private _opcoesSegmento;
    readonly opcoesSegmento: PoSelectOption[];
    constructor(global: GlobalService, formBuilder: FormBuilder, router: Router, activatedRoute: ActivatedRoute, unidadeIncluirService: UnidadeIncluirService);
    ngOnInit(): void;
    alterarUnidadeFederativa(uf: UnidadeFederativa): void;
    definirAcoesPagina(): void;
    salvar(): void;
    cancelar(): void;
    private voltar;
}
